tests: add `exec.skip` to compile but not execute tests
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export NIT_TESTING=true
23
24 unset NIT_DIR
25
26 # Get the first Java lib available
27 shopt -s nullglob
28 paths=`echo /usr/lib/jvm/*/`
29 paths=($paths)
30 JAVA_HOME=${paths[0]}
31
32 paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/`
33 paths=($paths)
34 JNI_LIB_PATH=${paths[0]}
35 shopt -u nullglob
36
37 usage()
38 {
39 e=`basename "$0"`
40 cat<<END
41 Usage: $e [options] modulenames
42 -o option Pass option to the engine
43 -v Verbose (show tests steps)
44 -h This help
45 --tap Produce TAP output
46 --engine Use a specific engine (default=nitg)
47 --noskip Do not skip a test even if the .skip file matches
48 --[no]soso Force enable (or disable) SOSO
49 END
50 }
51
52 # $1 is the pattern of the test
53 # $2 is the file to compare to
54 # the result is:
55 # 0: if the file to compare to do not exists
56 # 1: if the file match
57 # 2: if the file match with soso
58 # 3: if the file do not match
59 function compare_to_result()
60 {
61 local pattern="$1"
62 local sav="$2"
63 if [ ! -r "$sav" ]; then return 0; fi
64 diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
65 if [ "$?" == 0 ]; then
66 return 1
67 fi
68 [ -z "$soso" ] && return 3
69 sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
70 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
71 grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
72 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
73 diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log"
74 if [ "$?" == 0 ]; then
75 return 2
76 else
77 return 3
78 fi
79 }
80
81 # As argument: the pattern used for the file
82 function process_result()
83 {
84 ((tapcount=tapcount+1))
85 # Result
86 pattern=$1
87 description=$2
88 pack=$3
89 SAV=""
90 NSAV=""
91 FIXME=""
92 NFIXME=""
93 SOSO=""
94 NSOSO=""
95 SOSOF=""
96 NSOSOF=""
97 OLD=""
98 LIST=""
99 FIRST=""
100 echo >>$xml "<testcase classname='$pack' name='$description'>"
101 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
102 for savdir in $savdirs; do
103 sav=$savdir/$pattern.res
104 compare_to_result "$pattern" "$sav"
105
106 case "$? $sav" in
107 0*)
108 continue;; # no file
109 1*/fixme/*)
110 OLD="$LIST"
111 FIXME="$sav"
112 ;;
113 1*)
114 OLD="$LIST"
115 SAV="$sav"
116 ;;
117 2*/fixme/*)
118 SOSOF="$sav" ;;
119 2*)
120 SOSO="$sav" ;;
121 3*/fixme/*)
122 if [ -z "$FIRST" ]; then
123 NFIXME="$sav"
124 FIRST="$sav"
125 fi
126 ;;
127 3*)
128 if [ -z "$FIRST" ]; then
129 NSAV="$sav"
130 FIRST="$sav"
131 fi
132 ;;
133 esac
134 LIST="$LIST $sav"
135 done
136 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
137 grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
138 NYI="$?"
139 if [ -n "$SAV" ]; then
140 if [ -n "$tap" ]; then
141 echo "ok - $description"
142 elif [ -n "$OLD" ]; then
143 echo "[*ok*] out/$pattern.res $SAV - but $OLD remains!"
144 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
145 remains="$remains $OLD"
146 else
147 echo "[ok] out/$pattern.res $SAV"
148 fi
149 ok="$ok $pattern"
150 elif [ -n "$FIXME" ]; then
151 if [ -n "$tap" ]; then
152 echo "not ok - $description # TODO expected failure"
153 elif [ -n "$OLD" ]; then
154 echo "[*fixme*] out/$pattern.res $FIXME - but $OLD remains!"
155 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
156 remains="$remains $OLD"
157 else
158 echo "[fixme] out/$pattern.res $FIXME"
159 echo >>$xml "<skipped/>"
160 fi
161 todos="$todos $pattern"
162 elif [ -n "$SOSO" ]; then
163 if [ -n "$tap" ]; then
164 echo "ok - $description # SOSO"
165 else
166 echo "[soso] out/$pattern.res $SOSO"
167 fi
168 ok="$ok $pattern"
169 elif [ "x$NYI" = "x0" ]; then
170 if [ -n "$tap" ]; then
171 echo "not ok - $description # TODO not yet implemented"
172 else
173 echo "[todo] out/$pattern.res -> not yet implemented"
174 echo >>$xml "<skipped/>"
175 fi
176 todos="$todos $pattern"
177 elif [ -n "$SOSOF" ]; then
178 if [ -n "$tap" ]; then
179 echo "not ok - $description # TODO SOSO expected failure"
180 else
181 echo "[fixme soso] out/$pattern.res $SOSOF"
182 echo >>$xml "<skipped/>"
183 fi
184 todos="$todos $pattern"
185 elif [ -n "$NSAV" ]; then
186 if [ -n "$tap" ]; then
187 echo "not ok - $description"
188 else
189 echo "[======= fail out/$pattern.res $NSAV =======]"
190 fi
191 echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
192 echo >>$xml "<system-out><![CDATA["
193 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
194 echo >>$xml "]]></system-out>"
195 nok="$nok $pattern"
196 echo "$ii" >> "$ERRLIST"
197 elif [ -n "$NFIXME" ]; then
198 if [ -n "$tap" ]; then
199 echo "not ok - $description"
200 else
201 echo "[======= changed out/$pattern.res $NFIXME ======]"
202 fi
203 echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
204 echo >>$xml "<system-out><![CDATA["
205 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
206 echo >>$xml "]]></system-out>"
207 nok="$nok $pattern"
208 echo "$ii" >> "$ERRLIST"
209 else
210 if [ -n "$tap" ]; then
211 echo "ok - $description # skip no sav"
212 else
213 echo "[=== no sav ===] out/$pattern.res"
214 fi
215 echo >>$xml "<skipped/>"
216 echo >>$xml "<system-out><![CDATA["
217 cat -v >>$xml out/$pattern.res
218 echo >>$xml "]]></system-out>"
219 nos="$nos $pattern"
220 fi
221 if test -s out/$pattern.cmp.err; then
222 echo >>$xml "<system-err><![CDATA["
223 cat -v >>$xml out/$pattern.cmp.err
224 echo >>$xml "]]></system-err>"
225 fi
226 echo >>$xml "</testcase>"
227 }
228
229 need_skip()
230 {
231 test "$noskip" = true && return 1
232 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
233 ((tapcount=tapcount+1))
234 if [ -n "$tap" ]; then
235 echo "ok - $2 # skip"
236 else
237 echo "=> $2: [skip]"
238 fi
239 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
240 return 0
241 fi
242 return 1
243 }
244
245 skip_exec()
246 {
247 test "$noskip" = true && return 1
248 if echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
249 echo -n "_ "
250 return 0
251 fi
252 return 1
253 }
254
255 find_nitc()
256 {
257 ((tapcount=tapcount+1))
258 name="$enginebinname"
259 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
260 if [[ "x$recent" == "x" ]]; then
261 if [ -n "$tap" ]; then
262 echo "not ok - find binary for $engine"
263 echo "Bail out! Could not find binary for engine $engine, aborting"
264 else
265 echo "Could not find binary for engine $engine, aborting"
266 fi
267 exit 1
268 fi
269 if [ -n "$tap" ]; then
270 echo "ok - find binary for $engine: $recent $OPT"
271 else
272 echo "Find binary for engine $engine: $recent $OPT"
273 fi
274 NITC=$recent
275 }
276
277 verbose=false
278 stop=false
279 tapcount=0
280 engine=nitg
281 noskip=
282 while [ $stop = false ]; do
283 case $1 in
284 -o) OPT="$OPT $2"; shift; shift;;
285 -v) verbose=true; shift;;
286 -h) usage; exit;;
287 --tap) tap=true; shift;;
288 --engine) engine="$2"; shift; shift;;
289 --noskip) noskip=true; shift;;
290 --soso) soso=true; shift;;
291 --nososo) nososo=true; shift;;
292 *) stop=true
293 esac
294 done
295 enginebinname=$engine
296 case $engine in
297 nitg)
298 engine=nitg-s;
299 enginebinname=nitg;
300 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
301 OPT="--separate $OPT"
302 ;;
303 nitg-s)
304 enginebinname=nitg;
305 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
306 OPT="--separate $OPT"
307 ;;
308 nitg-e)
309 enginebinname=nitg;
310 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
311 OPT="--erasure $OPT"
312 ;;
313 nitg-g)
314 enginebinname=nitg;
315 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
316 OPT="--global $OPT"
317 ;;
318 nit)
319 engine=niti
320 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
321 ;;
322 niti)
323 enginebinname=nit
324 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
325 ;;
326 nitc)
327 echo "disabled engine $engine"
328 exit 0
329 ;;
330 *)
331 echo "unknown engine $engine"
332 exit 1
333 ;;
334 esac
335
336 # The default nitc compiler
337 [ -z "$NITC" ] && find_nitc
338
339 # Set NIT_DIR if needed
340 [ -z "$NIT_DIR" ] && export NIT_DIR=..
341
342 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
343 TIMEOUT="timelimit -t 600"
344 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
345 TIMEOUT="timeout 600s"
346 else
347 echo "No timelimit or timeout command detected. Tests may hang :("
348 fi
349
350 # Mark to distinguish files among tests
351 # MARK=
352
353 # File where error tests are outputed
354 # Old ERRLIST is backuped
355 ERRLIST=${ERRLIST:-errlist}
356 ERRLIST_TARGET=$ERRLIST
357
358 if [ $# = 0 ]; then
359 usage;
360 exit
361 fi
362
363 # Initiate new ERRLIST
364 if [ "x$ERRLIST" = "x" ]; then
365 ERRLIST=/dev=null
366 else
367 ERRLIST=$ERRLIST.tmp
368 > "$ERRLIST"
369 fi
370
371 ok=""
372 nok=""
373 todos=""
374 xml="tests-$engine.xml"
375 echo >$xml "<testsuites><testsuite>"
376
377 # CLEAN the out directory
378 rm -rf out/ 2>/dev/null
379 mkdir out 2>/dev/null
380
381 for ii in "$@"; do
382 if [ ! -f $ii ]; then
383 echo "File '$ii' does not exist."
384 continue
385 fi
386 f=`basename "$ii" .nit`
387
388 pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
389
390 # Sould we skip the file for this engine?
391 need_skip $f $f $pack && continue
392
393 tmp=${ii/../AA}
394 if [ "x$tmp" = "x$ii" ]; then
395 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
396 else
397 includes="-I alt"
398 fi
399
400 for i in "$ii" `./alterner.pl --start '#' --altsep '_' $ii`; do
401 bf=`basename $i .nit`
402 ff="out/$bf"
403
404 # Sould we skip the alternative for this engine?
405 need_skip $bf $bf $pack && continue
406
407 test -z "$tap" && echo -n "=> $bf: "
408
409 if [ -f "$f.inputs" ]; then
410 inputs="$f.inputs"
411 else
412 inputs=/dev/null
413 fi
414
415 if [ "$engine" = "niti" ]; then
416 cat > "./$ff.bin" <<END
417 exec $NITC --no-color $OPT "$i" $includes -- "\$@"
418 END
419 chmod +x "./$ff.bin"
420 > "$ff.cmp.err"
421 > "$ff.compile.log"
422 ERR=0
423 else
424 # Compile
425 if [ "x$verbose" = "xtrue" ]; then
426 echo ""
427 echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes"
428 fi
429 NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
430 $TIMEOUT $NITC --no-color $OPT -o "$ff.bin" "$i" $includes 2> "$ff.cmp.err" > "$ff.compile.log"
431 ERR=$?
432 if [ "x$verbose" = "xtrue" ]; then
433 cat "$ff.compile.log"
434 cat >&2 "$ff.cmp.err"
435 fi
436 fi
437 if [ "$ERR" != 0 ]; then
438 test -z "$tap" && echo -n "! "
439 cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
440 process_result $bf $bf $pack
441 elif skip_exec "$bf"; then
442 # No exec
443 > "$ff.res"
444 process_result $bf $bf $pack
445 elif [ -x "./$ff.bin" ]; then
446 test -z "$tap" && echo -n ". "
447 # Execute
448 args=""
449 if [ "x$verbose" = "xtrue" ]; then
450 echo ""
451 echo "NIT_NO_STACK=1 ./$ff.bin" $args
452 fi
453 NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
454 $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
455 if [ "x$verbose" = "xtrue" ]; then
456 cat "$ff.res"
457 cat >&2 "$ff.err"
458 fi
459 if [ -f "$ff.write" ]; then
460 cat "$ff.write" >> "$ff.res"
461 elif [ -d "$ff.write" ]; then
462 LANG=C /bin/ls -F $ff.write >> "$ff.res"
463 fi
464 cp "$ff.res" "$ff.res2"
465 cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
466 process_result $bf $bf $pack
467
468 if [ -f "$f.args" ]; then
469 fargs=$f.args
470 cptr=0
471 while read line; do
472 ((cptr=cptr+1))
473 args="$line"
474 bff=$bf"_args"$cptr
475 fff=$ff"_args"$cptr
476 name="$bf args $cptr"
477
478 # Sould we skip the input for this engine?
479 need_skip $bff " $name" $pack && continue
480
481 # use a specific inputs file, if required
482 if [ -f "$bff.inputs" ]; then
483 ffinputs="$bff.inputs"
484 else
485 ffinputs=$inputs
486 fi
487
488 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
489 if [ "x$verbose" = "xtrue" ]; then
490 echo ""
491 echo "NIT_NO_STACK=1 ./$ff.bin" $args
492 fi
493 test -z "$tap" && echo -n "==> $name "
494 echo "./$ff.bin $args" > "./$fff.bin"
495 chmod +x "./$fff.bin"
496 WRITE="$fff.write" sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $ffinputs > $fff.res 2>$fff.err"
497 if [ "x$verbose" = "xtrue" ]; then
498 cat "$fff.res"
499 cat >&2 "$fff.err"
500 fi
501 if [ -f "$fff.write" ]; then
502 cat "$fff.write" >> "$fff.res"
503 elif [ -d "$fff.write" ]; then
504 LANG=C /bin/ls -F $fff.write >> "$fff.res"
505 fi
506 if [ -s "$fff.err" ]; then
507 cp "$fff.res" "$fff.res2"
508 cat "$fff.err" "$fff.res2" > "$fff.res"
509 fi
510 process_result $bff " $name" $pack
511 done < $fargs
512 fi
513 elif [ -f "./$ff.bin" ]; then
514 echo "Not executable (platform?)" > "$ff.res"
515 process_result $bf "$bf" $pack
516 else
517 test -z "$tap" && echo -n "! "
518 cat "$ff.cmp.err" > "$ff.res"
519 echo "Compilation error" > "$ff.res"
520 process_result $bf "$bf" $pack
521 fi
522 done
523 done
524
525 if [ -n "$tap" ]; then
526 echo "1..$tapcount"
527 echo "# ok:" `echo $ok | wc -w`
528 echo "# not ok:" `echo $nok | wc -w`
529 echo "# no sav:" `echo $nos | wc -w`
530 echo "# todo/fixme:" `echo $todos | wc -w`
531 echo "# of sav that remains:" `echo $remains | wc -w`
532 exit
533 fi
534
535 echo "engine: $engine ($enginebinname $OPT)"
536 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
537
538 if [ -n "$nok" ]; then
539 echo "fail: $nok"
540 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
541 fi
542 if [ -n "$nos" ]; then
543 echo "no sav: $nos"
544 fi
545 if [ -n "$todos" ]; then
546 echo "todo/fixme: $todos"
547 fi
548 if [ -n "$remains" ]; then
549 echo "sav that remains: $remains"
550 fi
551
552 # write $ERRLIST
553 if [ "x$ERRLIST" != "x" ]; then
554 if [ -x "$ERRLIST_TARGET" ]; then
555 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
556 fi
557 mv $ERRLIST $ERRLIST_TARGET
558 fi
559
560 echo >>$xml "</testsuite></testsuites>"
561
562 if [ -n "$nok" ]; then
563 exit 1
564 else
565 exit 0
566 fi